#!/bin/bash

set -e
set -x

umask 0022

VERSION=${VERSION:-3.4.0}
VERSION_PARENT=${VERSION%.[0-9]}

CURRENT_DIR=$(pwd)

TMPDIR=$(mktemp -d /var/tmp/cairo-dock-XXXXXX)
pushd $TMPDIR

#wget -N http://launchpad.net/cairo-dock-core/${VERSION_PARENT}/${VERSION}/+download/cairo-dock-${VERSION}.tar.gz
wget -N https://github.com/Cairo-Dock/cairo-dock-core/archive/${VERSION}/cairo-dock-${VERSION}.tar.gz
rm -rf cairo-dock-${VERSION}
tar xzf cairo-dock-${VERSION}.tar.gz

if [ -d cairo-dock-core-${VERSION} ] ; then
	mv cairo-dock{-core,}-${VERSION}
fi

pushd cairo-dock-${VERSION}

set +x
echo -n -e "Modifying source \t"

count=0
sed -i -e '\@AVOID_PATENT_CRAP@d' src/gldit/gldi-config.h.in
grep -rIl AVOID_PATENT_CRAP src/ | while read f
do
	count=$((count + 1))
	mv $f $f.orig
	flag=1
	cat $f.orig | while IFS= read -r line
	do
		if ( echo "$line" | grep -q "#ifndef.*AVOID_PATENT_CRAP" ) ; then
			flag=10
			continue
		fi
		if [[ ( $flag == 10  ) && ( $(echo "$line" | grep -q "#else" ; echo $? ) == 0 ) ]] ; then
			flag=5
			continue
		fi
		if [[ ( $flag == 5  ) && ( $(echo "$line" | grep -q "#endif" ; echo $? ) == 0 ) ]] ; then
			flag=1
			continue
		fi
		[ $flag == 10 ] && continue
		echo "$line" >> $f
	done
	rm -f $f.orig
	if [ $count -ge 10 ] ; then
		count=$((count - 10))
		echo -n -e "."
	fi
done

echo "done"
set -x
popd

tar czf cairo-dock-fedora-${VERSION}.tar.gz cairo-dock-${VERSION}/
mv cairo-dock-fedora-${VERSION}.tar.gz ${CURRENT_DIR}/

popd
rm -rf $TMPDIR

